/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.CompilationUnitHelperNode;
import abstractsyntaxtree.CompilationUnitNode;
import abstractsyntaxtree.ImportDeclarationNode;
import abstractsyntaxtree.TjTypeDefNode;
import abstractsyntaxtree.TypeDeclarationNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractCompilationUnitVisitor extends Visitor {

    public abstract void begin(CompilationUnitNode node) throws exceptions.CompilerException;

    public abstract void visit(CompilationUnitNode node) throws exceptions.CompilerException;

    public abstract void end(CompilationUnitNode node) throws exceptions.CompilerException;

    public abstract void begin(TypeDeclarationNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TypeDeclarationNode node) throws exceptions.CompilerException;

    public abstract void end(TypeDeclarationNode node) throws exceptions.CompilerException;

    public abstract void begin(ImportDeclarationNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ImportDeclarationNode node) throws exceptions.CompilerException;

    public abstract void end(ImportDeclarationNode node) throws exceptions.CompilerException;

    public abstract void begin(CompilationUnitHelperNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(CompilationUnitHelperNode node) throws exceptions.CompilerException;

    public abstract void end(CompilationUnitHelperNode node) throws exceptions.CompilerException;

    public abstract void begin(TjTypeDefNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TjTypeDefNode node) throws exceptions.CompilerException;

    public abstract void end(TjTypeDefNode node) throws exceptions.CompilerException;
}
