/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression;

import abstractsyntaxtree.AssignmentOperatorNode;
import abstractsyntaxtree.Expression1Node;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractExpressionVisitor;
import teajay.bytecode.ClassFile;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class ExpressionVisitor extends AbstractExpressionVisitor {

    private final MethodInfo info;
    private final ClassFile classFile;

    public ExpressionVisitor(ClassFile classFile, MethodInfo info) {
        this.classFile = classFile;
        this.info = info;

    }

    @Override
    public void begin(Expression1Node node) {
    }

    @Override
    public void begin(AssignmentOperatorNode node) {
    }

    @Override
    public Visitor visit(Expression1Node node) {
        return new Expression1Visitor(this.classFile, this.info);
    }

    @Override
    public void visit(AssignmentOperatorNode node) {
    }

    @Override
    public void end(Expression1Node node) {
    }

    @Override
    public void end(AssignmentOperatorNode node) {
    }
//    @Override
//    public void begin(PrefixOpNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(ExpressionNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(TypeNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(PrimaryNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(SelectorNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(PostfixOpNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(Expression2RestNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(Expression1RestNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(AssignmentOperatorNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void begin(ExpressionHelperNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void visit(PrefixOpNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public Visitor visit(ExpressionNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public Visitor visit(TypeNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public Visitor visit(PrimaryNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public Visitor visit(SelectorNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void visit(PostfixOpNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public Visitor visit(Expression2RestNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public Visitor visit(Expression1RestNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void visit(AssignmentOperatorNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public Visitor visit(ExpressionHelperNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(PrefixOpNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(ExpressionNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(TypeNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(PrimaryNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(SelectorNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(PostfixOpNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(Expression2RestNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(Expression1RestNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(AssignmentOperatorNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
//
//    @Override
//    public void end(ExpressionHelperNode node) {
//        throw new UnsupportedOperationException("Not supported yet.");
//    }
}
