/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.compilationunit;

import codegeneration.abstractvisitors.AbstractTypeDeclarationVisitor;
import codegeneration.abstractvisitors.AbstractClassOrInterfaceDeclarationVisitor;
import abstractsyntaxtree.ClassOrInterfaceDeclaratioNode;
import abstractsyntaxtree.TjImplDeclarationNode;
import codegeneration.Visitor;
import codegeneration.javavisitor.ClassOrInterfaceDeclarationVisitor;
import exceptions.CompilerException;
import teajay.runtime.exceptions.ResolveException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import minicompiler.CompileManager;
import symbol.SymbolFacade;
import teajay.bytecode.ClassFile;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.util.io.ClassFinder;

/**
 *
 * @author cefour
 */
public class TypeDeclarationVisitor extends AbstractTypeDeclarationVisitor {

    private AbstractClassOrInterfaceDeclarationVisitor<ClassFile> classOrInterfaceDeclarationVisitor;
    private final String packageName;

    public TypeDeclarationVisitor(String packageName) {
        this.packageName = packageName;

    }

    @Override
    public void begin(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
        return this.classOrInterfaceDeclarationVisitor = new ClassOrInterfaceDeclarationVisitor(this.packageName);
    }

    @Override
    public void end(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
        ClassFile file = this.classOrInterfaceDeclarationVisitor.getClassFileContainer();

            //if (CompileManager.instance().getStage() == 2) {
            //    System.err.println("Write");
            //CompileManager.instance().writeClassFile(file);
            //} else {
            //ClassFinder.instance().addClassFile(file);

            //SymbolFacade.instance().addNameFromPackage(file.getThis().getClassName());
            //}
        
    }

    @Override
    public void begin(TjImplDeclarationNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TjImplDeclarationNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(TjImplDeclarationNode node) throws CompilerException {
    }
}
