/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression.expressiontransform;

import codegeneration.environment.ExpressionEnvironment;
import abstractsyntaxtree.ArgumentsNode;
import abstractsyntaxtree.ExplicitGenericInvocationNode;
import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.InnerCreatorNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import abstractsyntaxtree.SuperSuffixNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractSelectorVisitor;

/**
 *
 * @author cefour
 */
public class SelectorVisitor extends AbstractSelectorVisitor {

    private final String identifier;
    private final ExpressionEnvironment env;

    public SelectorVisitor(String identifier, ExpressionEnvironment env) {
        this.identifier = identifier;
        this.env = env;
    }

    @Override
    public void begin(ArgumentsNode node) {
    }

    @Override
    public void begin(ExplicitGenericInvocationNode node) {
    }

    @Override
    public void begin(SuperSuffixNode node) {
    }

    @Override
    public void begin(NonWildcardTypeArgumentsNode node) {
    }

    @Override
    public void begin(InnerCreatorNode node) {
    }

    @Override
    public void begin(ExpressionNode node) {
    }

    @Override
    public Visitor visit(ArgumentsNode node) {
        return new ArgumentsVisitor(env);
    }

    @Override
    public Visitor visit(ExplicitGenericInvocationNode node) {
        return null;
    }

    @Override
    public Visitor visit(SuperSuffixNode node) {
        return null;
    }

    @Override
    public Visitor visit(NonWildcardTypeArgumentsNode node) {
        return null;
    }

    @Override
    public Visitor visit(InnerCreatorNode node) {
        return null;
    }

    @Override
    public Visitor visit(ExpressionNode node) {
        return null;
    }

    @Override
    public void end(ArgumentsNode node) {
     //   try {
    //        MethodInfo methodCall = symbol.MethodResolver.existMethod(
      //              env.getResultType(), identifier, env.parametersType.toArray(new String[0]));
        //    if (methodCall == null) {
          //      throw new CompilerException("Method " + identifier + "(" + env.parametersType.toString() + " not found", node.getSymbol());
           // }

//            NameAndTypeInfo nameAndType = new NameAndTypeInfo(identifier, methodCall.getDescriptor());
//
//            MethodRefInfo mRef = new MethodRefInfo(env.getResultType(), nameAndType);
//            env.insertCode(new InvokeVirtual(mRef));
//            env.setResultType(methodCall.getDescriptor().getReturnType().getClassInfo().getClassName());
//        } catch (ByteCodeException | CompilerException | IOException | ResolveException ex) {
//            ex.printStackTrace(System.err);
//            System.exit(-1);
//        }
    }

    @Override
    public void end(ExplicitGenericInvocationNode node) {
    }

    @Override
    public void end(SuperSuffixNode node) {
    }

    @Override
    public void end(NonWildcardTypeArgumentsNode node) {
    }

    @Override
    public void end(InnerCreatorNode node) {
    }

    @Override
    public void end(ExpressionNode node) {
    }
}
