/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression.expressiontransform;

import codegeneration.environment.ExpressionEnvironment;
import abstractsyntaxtree.ArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractSuperSuffixVisitor;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import symbol.MethodResolver;
import teajay.bytecode.attributes.code.InvokeSpecial;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.cpool.MethodRefInfo;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.bytecode.methods.MethodInfo;
import teajay.runtime.exceptions.ResolveException;

/**
 *
 * @author cefour
 */
class SuperSuffixVisitor extends AbstractSuperSuffixVisitor {

    private final ExpressionEnvironment env;

    public SuperSuffixVisitor(ExpressionEnvironment env) {
        this.env = env;
    }

    @Override
    public void begin(ArgumentsNode node) {
    }

    @Override
    public Visitor visit(ArgumentsNode node) {
        return new ArgumentsVisitor(env);
    }

    @Override
    public void end(ArgumentsNode node) {
        MethodInfo info;
      /*  try {
            info = MethodResolver.existMethod(env.getFile().getSuper().getClassName(),
                    "<init>", env.parametersType.toArray(new String[0]));
            MethodRefInfo ref;
            ref = MethodRefInfo.make(env.getFile().getSuper(), "<init>", info.getDescriptor().getReturnType(), info.getDescriptor().getParameters().toArray(new FieldDescriptor[0]));
            env.insertCode(new InvokeSpecial(ref));
        } catch (ByteCodeException | IOException | ResolveException ex) {
            ex.printStackTrace(System.err);
            System.exit(-1);
        }
    }*/
    }
}
