/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package datastructs;

import abstractsyntaxtree.BlockNode;
import java.util.Objects;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
public class PairOfTypeAndBlock extends Pair<Type.ClassType, BlockNode>{

    public PairOfTypeAndBlock(Type.ClassType value1, BlockNode value2) {
        super(value1, value2);
    }
    
    @Override
    public boolean equals(Object obj){
        if(obj == null) return false;
        if(!(obj instanceof PairOfTypeAndBlock)) return false;
        PairOfTypeAndBlock o1 = ( PairOfTypeAndBlock) obj;
        if(o1.value1 == this.value1) return true;
        if(o1.value1 == null) return false;
        if(this.value1 == null) return false;
        
        return o1.value1.name.equals(this.value1.name);
        
        
    }

    @Override
    public int hashCode() {
        if (value1 == null) {
            return Objects.hashCode(null);
        }
        int hash = 7 * Objects.hashCode(value1.name);
        return hash;
    }
    
}
