/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.TjTypeDefBodyDeclarationNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTjTypeDefBodyVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
class Stage2TjTypeDefBodyVisitor extends AbstractTjTypeDefBodyVisitor {
    private final Stage2Environment stage2Env;

    public Stage2TjTypeDefBodyVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(TjTypeDefBodyDeclarationNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TjTypeDefBodyDeclarationNode node) throws CompilerException {
       
        return new Stage2TjTypeDefBodyDeclarationVisitor(stage2Env);
    }

    @Override
    public void end(TjTypeDefBodyDeclarationNode node) throws CompilerException {
    }
    
}
