/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3.states;

import abstractsyntaxtree.SyntaxNode;
import exceptions.CompilerException;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael (Burzan | Kußmann)
 */
public class MethodState extends AbstractState{
    private boolean isClosure = false;
    private boolean isClosureVoid = false;
    private Type.ClassType closureType = null;
    @Override
    public State changeState(BlockState state, SyntaxNode node) throws CompilerException {
        state.parent = this;
        return state;
        
    }

    public void setClosure(Type.ClassType closureType) {
        this.isClosure = true;
        this.closureType = closureType;
    }
    
    public Type.ClassType getClosureType() {
        return this.closureType;
    }

    public void setClosureIsVoid() {
        this.isClosure = true;
    }

    public void setClosureIsVoid(boolean aVoid) {
        this.isClosureVoid = aVoid;
    }
    public boolean isClosure(){
        return this.isClosure;
    }
    public boolean isVoidClosure(){
        return this.isClosureVoid;
    }
}
